#version 120

varying vec4 texcoord;
uniform sampler2D gcolor;

const float lrgb = 12.92;
const float lrgb_r = 10.314;
const float rgb_r = 0.00313;

void main() {
	
	vec2 point = texcoord.st;
	//get the current pixel color
	vec3 color = texture2D(gcolor, point).rgb*255;
	//convert to linear rgb
	
	color = vec3(color.r <= lrgb_r ? (color.r/255)/lrgb : pow((((color.r/255)+0.055)/1.055),2.4),
				 color.g <= lrgb_r ? (color.g/255)/lrgb : pow((((color.g/255)+0.055)/1.055),2.4),
				 color.b <= lrgb_r ? (color.b/255)/lrgb : pow((((color.b/255)+0.055)/1.055),2.4));

	//convert to LMS space (from lrgb thats first to XYZ and then LMS)
	color = vec3((color.r * 0.31399) + (color.g * 0.63951) + (color.b * 0.04649),
				 (color.r * 0.15537) + (color.g * 0.75789) + (color.b * 0.08670),
				 (color.r * 0.01775) + (color.g * 0.10944) + (color.b * 0.87256));

	//convert to tritan colorspace
	color = vec3((color.r * 1.0) + (color.g * 0.0) + (color.b * 0.0),
				 (color.r * 0.0) + (color.g * 1.0) + (color.b * 0.0),
				 (color.r * -0.86744) + (color.g * 1.86727) + (color.b * 0.0));

	//convert back into linear rgb
	color = vec3((color.r * 5.47221) + (color.g * -4.64196) + (color.b * 0.16963),
				 (color.r * -1.12524) + (color.g * 2.29317) + (color.b * -0.16789),
				 (color.r * 0.02980) + (color.g * -0.19318) + (color.b * 1.16364));
	
	//convert back to normal rgb
	color = vec3(color.r <= rgb_r ? (color.r*lrgb) : pow((1.055*color.r),0.4166)-0.055,
				 color.g <= rgb_r ? (color.g*lrgb) : pow((1.055*color.g),0.4166)-0.055,
				 color.b <= rgb_r ? (color.b*lrgb) : pow((1.055*color.b),0.4166)-0.055);

	//set final pixel color
	gl_FragColor = vec4(color, 1.0);
}
